// Author: Patrick Stickler <patrick.stickler@nokia.com>
// Copyright (C) 2002 Nokia. All rights reserved.
// Usage is governed by the license terms defined in the file
// NOKIA_LICENSE which was distributed with this file.

package Datatypes;

public class Test
{
   public Test ()
   {
   }
   
   public static void main (java.lang.String[] args)
   {
      java.lang.String data[] = new java.lang.String[]
      {
         "http://www.w3.org/2001/XMLSchema#integer", "10",
         "http://www.w3.org/2001/XMLSchema#integer", "010",
         
         "http://www.w3.org/2001/XMLSchema#integer", "10",
         "http://abc.com/Integer", "010",
         
         "http://www.w3.org/2001/XMLSchema#integer", "10.000",
         "http://www.w3.org/2001/XMLSchema#integer", "+010",
         
         "http://www.w3.org/2001/XMLSchema#integer", "10",
         "http://www.w3.org/2001/XMLSchema#byte",    "010",
         
         "http://www.w3.org/2001/XMLSchema#decimal", "10.0",
         "http://www.w3.org/2001/XMLSchema#integer", "5",
         
         "http://www.w3.org/2001/XMLSchema#integer", "5",
         "http://www.w3.org/2001/XMLSchema#integer", "000010",
         
         "http://www.w3.org/2001/XMLSchema#integer", "10",
         "http://www.w3.org/2001/XMLSchema#string",  "10",
         
         "http://www.w3.org/2001/XMLSchema#string",  "abc",
         "http://www.w3.org/2001/XMLSchema#string",  "abc",
         
         "http://www.w3.org/2001/XMLSchema#string",  "abcd",
         "http://www.w3.org/2001/XMLSchema#string",  "abc",
         
         "http://www.w3.org/2001/XMLSchema#string",  "abc",
         "http://www.w3.org/2001/XMLSchema#string",  "xyz",
         
         "http://www.w3.org/2001/XMLSchema#language",  "en",
         "http://www.w3.org/2001/XMLSchema#language",  "fi",
         
         "http://www.w3.org/2001/XMLSchema#string",  "se",
         "http://www.w3.org/2001/XMLSchema#language",  "se",
         
         "http://www.w3.org/2001/XMLSchema#integer", "X10",
         "http://www.w3.org/2001/XMLSchema#byte",    "345",
         
         "http://www.w3.org/2001/XMLSchema#string", "foo",
         "http://www.w3.org/2001/XMLSchema#name", "foo",
         
         "http://www.w3.org/2001/XMLSchema#name", "foo",
         "http://www.wapforum.org/profiles/UAPROF/ccppschema-20010430#Literal", "foo",
         
         "http://www.w3.org/2001/XMLSchema#name", "foo:bar",
         "http://www.wapforum.org/profiles/UAPROF/ccppschema-20010430#Literal", "foo:bar",
         
         "http://www.w3.org/2001/XMLSchema#string", "10",
         "http://www.w3.org/2001/XMLSchema#name", "10",
         
         "http://www.w3.org/2001/XMLSchema#dateTime", "1999-05-20T14:08:51Z",
         "voc://nokia.com/MARS-3.0/Date", "1999-05-20T14:08:51Z",
         
         "http://www.w3.org/2001/XMLSchema#dateTime", "1999-05-20T14:08:51Z",
         "voc://nokia.com/MARS-3.0/Date", "1999-05-20T14:08:00Z",
         
         "http://www.w3.org/2001/XMLSchema#dateTime", "1999-05-20T16:08:51-02:00",
         "voc://nokia.com/MARS-3.0/Date", "1999-05-20T14:08:51Z",
         
         "http://www.w3.org/2001/XMLSchema#dateTime", "1999-05-20T14:08:51Z",
         "voc://nokia.com/MARS-3.0/Date", "1999-05-20T16:08:51-02:00",
         
         "http://www.wapforum.org/profiles/UAPROF/ccppschema-20010430#Dimension", "640x480",
         "http://www.wapforum.org/profiles/UAPROF/ccppschema-20010430#Dimension", "640x480",
         
         "http://www.wapforum.org/profiles/UAPROF/ccppschema-20010430#Dimension", "640",
         "http://www.wapforum.org/profiles/UAPROF/ccppschema-20010430#Dimension", "640x480",
         
         "http://www.wapforum.org/profiles/UAPROF/ccppschema-20010430#Dimension", "100x200",
         "http://www.wapforum.org/profiles/UAPROF/ccppschema-20010430#Dimension", "640x480",
         
         "http://www.wapforum.org/profiles/UAPROF/ccppschema-20010430#Number", "10",
         "voc://nokia.com/MARS-3.0/Integer", "10",
         
         "http://www.wapforum.org/profiles/UAPROF/ccppschema-20010430#Number", "10",
         "http://www.w3.org/2001/XMLSchema#byte", "10",
         
         "http://www.wapforum.org/profiles/UAPROF/ccppschema-20010430#Boolean", "Yes",
         "http://www.w3.org/2001/XMLSchema#boolean", "1",
         
      };
      
      // Load datatype URI to Java class name map:
      
      // Normally, the registry would be loaded from an external
      // configuration file which defines the URI to classname
      // mappings without need to modify any code when new
      // datatypes are taken into use, but in the interest of
      // keeping this example simple, they are defined here
      // explicitly.
      
      Datatype.register ("http://www.w3.org/2001/XMLSchema#boolean", "XSD.Boolean");
      Datatype.register ("http://www.w3.org/2001/XMLSchema#decimal", "XSD.Decimal");
      Datatype.register ("http://www.w3.org/2001/XMLSchema#integer", "XSD.Integer");
      Datatype.register ("http://www.w3.org/2001/XMLSchema#long", "XSD.Long");
      Datatype.register ("http://www.w3.org/2001/XMLSchema#int", "XSD.Int");
      Datatype.register ("http://www.w3.org/2001/XMLSchema#short", "XSD.Short");
      Datatype.register ("http://www.w3.org/2001/XMLSchema#byte", "XSD.Byte");
      Datatype.register ("http://www.w3.org/2001/XMLSchema#string", "XSD.String");
      Datatype.register ("http://www.w3.org/2001/XMLSchema#normalizedString", "XSD.NormalizedString");
      Datatype.register ("http://www.w3.org/2001/XMLSchema#token", "XSD.Token");
      Datatype.register ("http://www.w3.org/2001/XMLSchema#language", "XSD.Language");
      Datatype.register ("http://www.w3.org/2001/XMLSchema#name", "XSD.Name");
      Datatype.register ("http://www.w3.org/2001/XMLSchema#dateTime", "XSD.DateTime");
      
      Datatype.register ("voc://nokia.com/MARS-3.0/Integer", "MARS.Integer");
      Datatype.register ("voc://nokia.com/MARS-3.0/Count", "MARS.Count");
      Datatype.register ("voc://nokia.com/MARS-3.0/Date", "MARS.Date");
      
      Datatype.register ("http://www.wapforum.org/profiles/UAPROF/ccppschema-20010430#Boolean", "UAProf.Boolean");
      Datatype.register ("http://www.wapforum.org/profiles/UAPROF/ccppschema-20010430#Dimension", "UAProf.Dimension");
      Datatype.register ("http://www.wapforum.org/profiles/UAPROF/ccppschema-20010430#Literal", "UAProf.Literal");
      Datatype.register ("http://www.wapforum.org/profiles/UAPROF/ccppschema-20010430#Number", "UAProf.Number");
      
      // Process test data...
      
      for (int i = 0; i < data.length; i = i + 4)
      {
         java.lang.String   uriX   = data[i];
         java.lang.String   lformX = data[i+1];
         java.lang.String   uriY   = data[i+2];
         java.lang.String   lformY = data[i+3];
         Datatypes.Datatype valueX = null;
         Datatypes.Datatype valueY = null;
         boolean            failed = false;
         
         System.out.println ("Typed Literal X: <" + uriX + ">\"" + lformX + "\"");
         
         try
         {
            valueX = Datatype.value (uriX, lformX);
            Class datatype = valueX.getClass ();
            System.out.println ("Class X: " + datatype.getName ());
            System.out.println ("Value X: " + valueX.lexicalForm ());
         }
         catch (Exception e)
         {
            System.out.println ("Exception: " + e.getClass ().getName () + ": " + e.getMessage ());
            failed = true;
         }
         
         System.out.println ("Typed Literal Y: <" + uriY + ">\"" + lformY + "\"");
         
         try
         {
            valueY = Datatype.value (uriY, lformY);
            Class datatype = valueY.getClass ();
            System.out.println ("Class Y: " + datatype.getName ());
            System.out.println ("Value Y: " + valueY.lexicalForm ());
         }
         catch (Exception e)
         {
            System.out.println ("Exception: " + e.getClass ().getName () + ": " + e.getMessage ());
            failed = true;
         }
         
         if (! failed)
         {
            System.out.print ("Equal: ");
            try
            {
               if (valueX.equals (valueY))
                  System.out.print ("true");
               else
                  System.out.print ("false");
            }
            catch (Exception e)
            {
               System.out.print ("Exception: " + e.getClass ().getName () + ": " + e.getMessage ());
            }
            System.out.println ();
            
            System.out.print ("Order: ");
            try
            {
               int result = valueX.compareTo (valueY);
               switch (result)
               {
                  case -1 : System.out.print ("X < Y"); break;
                  case  0 : System.out.print ("X = Y"); break;
                  case  1 : System.out.print ("X > Y"); break;
                  default : System.out.print ("X ? Y: " + result); break;
               }
            }
            catch (Exception e)
            {
               System.out.print ("Exception: " + e.getClass ().getName () + ": " + e.getMessage ());
            }
            System.out.println ();
            
         }
         System.out.println ();
      }
   }
}
