// Author: Patrick Stickler <patrick.stickler@nokia.com>
// Copyright (C) 2002 Nokia. All rights reserved.
// Usage is governed by the license terms defined in the file
// NOKIA_LICENSE which was distributed with this file.

package MARS;

import Datatypes.*;
import java.util.regex.*;

public class Date extends XSD.DateTime
{
   private static final Pattern pattern = Pattern.compile ("\\A[0-9]{4}-[0-9]{2}-[0-9]{2}T(([01][0-9])|(2[0-3])):[0-5][0-9]:[0-5][0-9]Z\\Z");
   
   public Date ()
   {
   }
   
   public Date (java.lang.String lform)
   throws InvalidLexicalForm
   {
      this.setValue (lform);
   }
   
   public boolean isValidForm (java.lang.String lform)
   {
      Matcher matcher = pattern.matcher (lform);
      return matcher.matches ();
   }
}
