// Author: Patrick Stickler <patrick.stickler@nokia.com>
// Copyright (C) 2002 Nokia. All rights reserved.
// Usage is governed by the license terms defined in the file
// NOKIA_LICENSE which was distributed with this file.

package UAProf;

import Datatypes.*;
import java.util.regex.*;

public class Boolean extends XSD.Boolean
{
   private static final Pattern pattern = Pattern.compile ("\\A(Yes)|(No)\\Z");
   
   public Boolean ()
   {
   }
   
   public Boolean (java.lang.String lform)
   throws InvalidLexicalForm
   {
      this.setValue (lform);
   }
   
   public java.lang.String lexicalForm ()
   {
      final java.lang.Integer yes = new java.lang.Integer (1);
      
      if (nativeValue.equals (yes))
         return "Yes";
      else
         return "No";
   }
   
   public void setValue (java.lang.String lform)
   throws InvalidLexicalForm
   {
      if (! this.isValidForm (lform)) throw new InvalidLexicalForm (lform);
      
      if (lform.equals ("Yes"))
         nativeValue = new java.lang.Integer (1);
      else
         nativeValue = new java.lang.Integer (0);
   }
   
   public boolean isValidForm (java.lang.String lform)
   {
      Matcher matcher = pattern.matcher (lform);
      return matcher.matches ();
   }
}
