// Author: Patrick Stickler <patrick.stickler@nokia.com>
// Copyright (C) 2002 Nokia. All rights reserved.
// Usage is governed by the license terms defined in the file
// NOKIA_LICENSE which was distributed with this file.

package UAProf;

import Datatypes.*;
import java.util.regex.*;

public class Literal extends XSD.Name
{
   private static final Pattern pattern = Pattern.compile ("\\A[^:]+\\Z");
   
   public Literal ()
   {
   }
   
   public Literal (java.lang.String lform) throws InvalidLexicalForm
   {
      this.setValue (lform);
   }
   
   public boolean isValidForm (java.lang.String lform)
   {
      if (! super.isValidForm (lform)) return false;
      Matcher matcher = pattern.matcher (lform);
      return matcher.matches ();
   }
}
