// Author: Patrick Stickler <patrick.stickler@nokia.com>
// Copyright (C) 2002 Nokia. All rights reserved.
// Usage is governed by the license terms defined in the file
// NOKIA_LICENSE which was distributed with this file.

package XSD;

import java.util.regex.*;
import Datatypes.*;

public class Integer extends Decimal
{
   private static final Pattern pattern = Pattern.compile ("\\A[^\\.]+\\Z");
   
   public Integer ()
   {
   }
   
   public Integer (java.lang.String lform)
   throws InvalidLexicalForm
   {
      this.setValue (lform);
   }
   
   public java.lang.String lexicalForm ()
   {
      java.lang.Double value = getNativeValue ();
      java.lang.Integer i = new java.lang.Integer (value.intValue ());
      return i.toString ();
   }
   
   public boolean isValidForm (java.lang.String lform)
   {
      if (! super.isValidForm (lform)) return false;
      Matcher matcher = pattern.matcher (lform);
      return matcher.matches ();
   }
}
