// Author: Patrick Stickler <patrick.stickler@nokia.com>
// Copyright (C) 2002 Nokia. All rights reserved.
// Usage is governed by the license terms defined in the file
// NOKIA_LICENSE which was distributed with this file.

package XSD;

import java.util.HashSet;
import java.util.regex.*;
import Datatypes.*;

public class Language extends Token
{
   private static final Pattern pattern = Pattern.compile ("\\A(aa)|(ab)|(af)|(am)|(ar)|(as)|(ay)|(az)|(ba)|(be)|(bg)|(bh)|(bi)|(bn)|(bo)|(br)|(ca)|(co)|(cs)|(cy)|(da)|(de)|(dz)|(el)|(en)|(eo)|(es)|(et)|(eu)|(fa)|(fi)|(fj)|(fo)|(fr)|(fy)|(ga)|(gd)|(gl)|(gn)|(gu)|(ha)|(hi)|(hr)|(hu)|(hy)|(ia)|(ie)|(ik)|(in)|(is)|(it)|(iw)|(ja)|(ji)|(jw)|(ka)|(kk)|(kl)|(km)|(kn)|(ko)|(ks)|(ku)|(ky)|(la)|(ln)|(lo)|(lt)|(lv)|(mg)|(mi)|(mk)|(ml)|(mn)|(mo)|(mr)|(ms)|(mt)|(my)|(na)|(ne)|(nl)|(no)|(oc)|(om)|(or)|(pa)|(pl)|(ps)|(pt)|(qu)|(rm)|(rn)|(ro)|(ru)|(rw)|(sa)|(sd)|(sg)|(sh)|(si)|(sk)|(sl)|(sm)|(sn)|(so)|(sq)|(sr)|(ss)|(st)|(su)|(sv)|(sw)|(ta)|(te)|(tg)|(th)|(ti)|(tk)|(tl)|(tn)|(to)|(tr)|(ts)|(tt)|(tw)|(uk)|(ur)|(uz)|(vi)|(vo)|(wo)|(xh)|(yo)|(zh)\\Z");
   
   public Language ()
   {
   }
   
   public Language (java.lang.String lform)
   throws InvalidLexicalForm
   {
      this.setValue (lform);
   }
   
   public boolean isValidForm (java.lang.String lform)
   {
      Matcher matcher = pattern.matcher (lform);
      return matcher.matches ();
   }
}
