// Author: Patrick Stickler <patrick.stickler@nokia.com>
// Copyright (C) 2002 Nokia. All rights reserved.
// Usage is governed by the license terms defined in the file
// NOKIA_LICENSE which was distributed with this file.

package XSD;

import Datatypes.*;
import java.util.regex.*;

public class NonNegativeInteger extends Integer
{
   private static final Pattern xpattern = Pattern.compile ("\\A-");
   
   public NonNegativeInteger ()
   {
   }
   
   public NonNegativeInteger (java.lang.String lform)
   throws InvalidLexicalForm
   {
      this.setValue (lform);
   }
   
   public boolean isValidForm (java.lang.String lform)
   {
      if (! super.isValidForm (lform)) return false;
      Matcher matcher = xpattern.matcher (lform);
      if (matcher.matches ()) return false;
      return true;
   }
}
