// Author: Patrick Stickler <patrick.stickler@nokia.com>
// Copyright (C) 2002 Nokia. All rights reserved.
// Usage is governed by the license terms defined in the file
// NOKIA_LICENSE which was distributed with this file.

package XSD;

import java.util.regex.*;
import Datatypes.*;

public class NormalizedString extends String
{
   private static final Pattern pattern = Pattern.compile ("\\A[^\\x0D\\x09]+\\Z");

   public NormalizedString ()
   {
   }
   
   public NormalizedString (java.lang.String lform)
   throws InvalidLexicalForm
   {
      this.setValue (lform);
   }
   
   public boolean isValidForm (java.lang.String lform)
   {
      Matcher matcher = pattern.matcher (lform);
      return matcher.matches ();
   }
}
