// Author: Patrick Stickler <patrick.stickler@nokia.com>
// Copyright (C) 2002 Nokia. All rights reserved.
// Usage is governed by the license terms defined in the file
// NOKIA_LICENSE which was distributed with this file.

package XSD;

import java.util.regex.*;
import Datatypes.*;

public class Token extends NormalizedString
{
   private static final Pattern xpattern1 = Pattern.compile ("\\A\\x20.*\\Z");
   private static final Pattern xpattern2 = Pattern.compile ("\\A.*\\x20\\Z");
   private static final Pattern xpattern3 = Pattern.compile ("\\A.*\\x20\\x20.*\\Z");
   
   public Token ()
   {
   }
   
   public Token (java.lang.String lform)
   throws InvalidLexicalForm
   {
      this.setValue (lform);
   }
    
   public boolean isValidForm (java.lang.String lform)
   {
      if (! super.isValidForm (lform)) return false;
      
      Matcher matcher = xpattern1.matcher (lform);
      if (matcher.matches ()) return false;
      
      matcher = xpattern2.matcher (lform);
      if (matcher.matches ()) return false;
      
      matcher = xpattern3.matcher (lform);
      if (matcher.matches ()) return false;
      
      return true;
   }
}
